searchData={"items":[{"type":"module","title":"SimpleRijndael","doc":"Wrapper module to interact with the Rust NIF for the `simple_rijndael` Rust crate.","ref":"SimpleRijndael.html"},{"type":"function","title":"SimpleRijndael.decrypt/3","doc":"Decrypts the given data using the Rijndael cipher and the given initialization vector.","ref":"SimpleRijndael.html#decrypt/3"},{"type":"function","title":"SimpleRijndael.encrypt/3","doc":"Encrypts the given data using the Rijndael cipher and the given initialization vector.","ref":"SimpleRijndael.html#encrypt/3"},{"type":"function","title":"SimpleRijndael.init_cbc_mode/3","doc":"Initializes the low-level Rijndael struct in CBC mode with the given key, block size (in bytes), and padding.","ref":"SimpleRijndael.html#init_cbc_mode/3"},{"type":"type","title":"SimpleRijndael.error/0","doc":"The error types that can be returned by the NIF.","ref":"SimpleRijndael.html#t:error/0"},{"type":"type","title":"SimpleRijndael.padding/0","doc":"The padding types that can be used for the Rijndael cipher.","ref":"SimpleRijndael.html#t:padding/0"},{"type":"extras","title":"simple-rijndael for Elixir","doc":"# simple-rijndael for Elixir\n\nA binding to the PurePeace's simple-rijndael Rust crate for Elixir.\n\n[![PayPal](https://img.shields.io/badge/Paypal-003087?style=for-the-badge&logo=paypal&logoColor=%23fff)\n](https://www.paypal.com/donate/?business=QQGMTC3FQAJF6&no_recurring=0&item_name=Thanks+for+donating+for+me%2C+this+helps+me+a+lot+to+continue+developing+and+maintaining+my+projects.&currency_code=USD)\n[![GitHub Sponsor](https://img.shields.io/badge/GitHub%20Sponsor-181717?style=for-the-badge&logo=github&logoColor=%23fff)\n](https://github.com/sponsors/nashiradeer)\n[![Hex.pm](https://img.shields.io/hexpm/v/simple-rijndael?style=for-the-badge&logo=elixir&logoColor=%23fff&label=Hex.pm&labelColor=%234B275F&color=%234B275F)](https://hex.pm/packages/simple_rijndael)\n[![HexDocs.pm](https://img.shields.io/badge/HexDocs.pm-4B275F?style=for-the-badge&logo=elixir&logoColor=%23fff)\n](https://hexdocs.pm/simple_rijndael/)","ref":"readme.html"},{"type":"extras","title":"Motivation - simple-rijndael for Elixir","doc":"AES has removed the block size of 256 bits from the standard and if a old system is using it AES willn't work (my case) and there's no Rijndael implementations in Erlang or Elixir.","ref":"readme.html#motivation"},{"type":"extras","title":"Installation - simple-rijndael for Elixir","doc":"**Warning:** You will need the [Rust compiler](https://www.rust-lang.org/tools/install) to compile this package.\n\nThis package has been published in [Hex.pm](https://hex.pm/packages/simple_rinjdael) and you can use it with:\n\n```elixir\ndef deps do\n  [\n    {:simple_rijndael, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - simple-rijndael for Elixir","doc":"```elixir\nkey = :crypto.strong_rand_bytes(32)\niv = :crypto.strong_rand_bytes(32)\n\n# Padding options:\n#   :pkcs7\n#   :zero\n{:ok, cipher} = SimpleRijndael.init_cbc_mode(key, 32, :pkcs7)\n\ndata = \"Hello, World!\"\n\n{:ok, encrypted} = SimpleRijndael.encrypt(cipher, iv, data)\n\n{:ok, decrypted} = SimpleRijndael.decrypt(cipher, iv, encrypted)\n\n# If an error occour, will be one of the following returns:\n#   {:error, :invalid_data_size}\n#   {:error, :invalid_key_size}\n#   {:error, :invalid_block_size}\n#\n# Or an exception of ErlangError with reason == nil and original == :nif_panicked\n```","ref":"readme.html#usage"},{"type":"extras","title":"Credits - simple-rijndael for Elixir","doc":"**Simple Rijndael for Elixir** is a project by [Nashira Deer](https://github.com/nashiradeer), licensed under [MIT License](https://github.com/nashiradeer/simple-rijndael-4elixir/blob/main/LICENSE.txt).","ref":"readme.html#credits"},{"type":"extras","title":"LICENSE","doc":"Copyright 2024 Nashira Deer\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the “Software”), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}